<template>
  <view-list
    v-on:model-reload="loadList"
    v-on:export-csv="downloadCsv"
    v-on:model-search="search($event.query, $event.field)"
    :status="status"
    title="Wyposażenie"
    :button="true"
    button_link="/wyposazenie/nowe"
    button_title="Dodaj nowy element wyposażenia"
    :length="filteredData.length"
  >
    <RecycleScroller :items="filteredData" :item-size="106" v-if="renderHack">
      <template v-slot="{ item }">
        <item-list-item v-bind="item" />
      </template>
    </RecycleScroller>
  </view-list>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import ViewList from "@/views/list-views/ViewList.vue";
import ItemListItem from "@/components/list/custom/ItemListItem.vue";

import {
  CsvDownload,
  ItemData,
  LoadingState,
  LocationData,
} from "@/interfaces";
import RecordList from "@/views/list-views/RecordList";
import { NApi } from "@/interfaces/connector";
import Fuse from "fuse.js";

@Options({
  components: {
    ViewList,
    ItemListItem,
  },
})
export default class Items extends RecordList<ItemData> {
  public API_CALL = NApi.getItems;

  async downloadCsv() {
    await new CsvDownload(" ; ").download(this.filteredData);
  }

  async onLoaded(data: ItemData[]) {
    const options = {
      includeScore: false,
      keys: [
        "name",
        { name: "description", weight: 0.2 },
        "serial_number",
        "part_number",
      ],
    };

    this.rawData = data;
    this.fuseData = Object.freeze(new Fuse(data, options));
    this.filter();
  }
}
</script>
